diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/utils/mac16-address.cc ns-3.39/src/network/utils/mac16-address.cc
--- ns-3.38/src/network/utils/mac16-address.cc	2023-03-16 20:54:23.808869100 -0700
+++ ns-3.39/src/network/utils/mac16-address.cc	2023-07-05 14:23:48.065428300 -0700
@@ -104,6 +104,13 @@
     NS_ASSERT(i == 2);
 }
 
+Mac16Address::Mac16Address(uint16_t addr)
+{
+    NS_LOG_FUNCTION(this);
+    m_address[1] = addr & 0xFF;
+    m_address[0] = (addr >> 8) & 0xFF;
+}
+
 void
 Mac16Address::CopyFrom(const uint8_t buffer[2])
 {
@@ -147,6 +154,15 @@
     return Address(GetType(), m_address, 2);
 }
 
+uint16_t
+Mac16Address::ConvertToInt() const
+{
+    uint16_t addr = m_address[1] & (0xFF);
+    addr |= (m_address[0] << 8) & (0xFF << 8);
+
+    return addr;
+}
+
 Mac16Address
 Mac16Address::Allocate()
 {
@@ -212,11 +228,7 @@
 Mac16Address::IsBroadcast() const
 {
     NS_LOG_FUNCTION(this);
-    if (m_address[0] == 0xff && m_address[1] == 0xff)
-    {
-        return true;
-    }
-    return false;
+    return m_address[0] == 0xff && m_address[1] == 0xff;
 }
 
 bool
@@ -225,11 +237,7 @@
     NS_LOG_FUNCTION(this);
     uint8_t val = m_address[0];
     val >>= 5;
-    if (val == 0x4)
-    {
-        return true;
-    }
-    return false;
+    return val == 0x4;
 }
 
 std::ostream&
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/utils/mac16-address.h ns-3.39/src/network/utils/mac16-address.h
--- ns-3.38/src/network/utils/mac16-address.h	2023-03-16 20:54:23.808869100 -0700
+++ ns-3.39/src/network/utils/mac16-address.h	2023-07-05 14:23:48.065428300 -0700
@@ -51,23 +51,33 @@
     Mac16Address(const char* str);
 
     /**
+     * \param addr The 16 bit unsigned integer used to create a Mac16Address object.
+     *
+     * Create a Mac16Address from an 16 bit unsigned integer.
+     */
+    Mac16Address(uint16_t addr);
+
+    /**
      * \param buffer address in network order
      *
      * Copy the input address to our internal buffer.
      */
     void CopyFrom(const uint8_t buffer[2]);
+
     /**
      * \param buffer address in network order
      *
      * Copy the internal address to the input buffer.
      */
     void CopyTo(uint8_t buffer[2]) const;
+
     /**
      * \returns a new Address instance
      *
      * Convert an instance of this class to a polymorphic Address instance.
      */
     operator Address() const;
+
     /**
      * \param address a polymorphic address
      * \returns a new Mac16Address from the polymorphic address
@@ -77,6 +87,7 @@
      * Mac16Address.
      */
     static Mac16Address ConvertFrom(const Address& address);
+
     /**
      * \returns a new Address instance
      *
@@ -85,10 +96,18 @@
     Address ConvertTo() const;
 
     /**
+     * \return the mac address in a 16 bit unsigned integer
+     *
+     * Convert an instance of this class to a 16 bit unsigned integer.
+     */
+    uint16_t ConvertToInt() const;
+
+    /**
      * \param address address to test
      * \returns true if the address matches, false otherwise.
      */
     static bool IsMatchingType(const Address& address);
+
     /**
      * Allocate a new Mac16Address.
      * \returns newly allocated mac16Address
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/utils/mac64-address.cc ns-3.39/src/network/utils/mac64-address.cc
--- ns-3.38/src/network/utils/mac64-address.cc	2023-03-16 20:54:23.808869100 -0700
+++ ns-3.39/src/network/utils/mac64-address.cc	2023-07-05 14:23:48.065428300 -0700
@@ -104,6 +104,19 @@
     NS_ASSERT(i == 8);
 }
 
+Mac64Address::Mac64Address(uint64_t addr)
+{
+    NS_LOG_FUNCTION(this);
+    m_address[7] = addr & 0xFF;
+    m_address[6] = (addr >> 8) & 0xFF;
+    m_address[5] = (addr >> 16) & 0xFF;
+    m_address[4] = (addr >> 24) & 0xFF;
+    m_address[3] = (addr >> 32) & 0xFF;
+    m_address[2] = (addr >> 40) & 0xFF;
+    m_address[1] = (addr >> 48) & 0xFF;
+    m_address[0] = (addr >> 56) & 0xFF;
+}
+
 void
 Mac64Address::CopyFrom(const uint8_t buffer[8])
 {
@@ -147,6 +160,23 @@
     return Address(GetType(), m_address, 8);
 }
 
+uint64_t
+Mac64Address::ConvertToInt() const
+{
+    uint64_t shift = 0xFF;
+    uint64_t addr = static_cast<uint64_t>(m_address[7]) & (shift);
+    addr |= (static_cast<uint64_t>(m_address[6]) << 8) & (shift << 8);
+    addr |= (static_cast<uint64_t>(m_address[5]) << 16) & (shift << 16);
+    addr |= (static_cast<uint64_t>(m_address[4]) << 24) & (shift << 24);
+
+    addr |= (static_cast<uint64_t>(m_address[3]) << 32) & (shift << 32);
+    addr |= (static_cast<uint64_t>(m_address[2]) << 40) & (shift << 40);
+    addr |= (static_cast<uint64_t>(m_address[1]) << 48) & (shift << 48);
+    addr |= (static_cast<uint64_t>(m_address[0]) << 56) & (shift << 56);
+
+    return addr;
+}
+
 Mac64Address
 Mac64Address::Allocate()
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/utils/mac64-address.h ns-3.39/src/network/utils/mac64-address.h
--- ns-3.38/src/network/utils/mac64-address.h	2023-03-16 20:54:23.808869100 -0700
+++ ns-3.39/src/network/utils/mac64-address.h	2023-07-05 14:23:48.065428300 -0700
@@ -49,11 +49,18 @@
     /**
      * \param str a string representing the new Mac64Address
      *
-     * The format of the string is "xx:xx:xx:xx:xx:xx"
+     * The format of the string is "xx:xx:xx:xx:xx:xx:xx:xx"
      */
     Mac64Address(const char* str);
 
     /**
+     * \param addr The 64 bit unsigned integer used to create a Mac64Address object.
+     *
+     * Create a Mac64Address from an 64 bit unsigned integer.
+     */
+    Mac64Address(uint64_t addr);
+
+    /**
      * \param buffer address in network order
      *
      * Copy the input address to our internal buffer.
@@ -88,6 +95,13 @@
     Address ConvertTo() const;
 
     /**
+     * \return the mac address in a 64 bit unsigned integer.
+     *
+     * Convert an instance of this class to a 64 bit unsigned integer.
+     */
+    uint64_t ConvertToInt() const;
+
+    /**
      * \param address address to test
      * \returns true if the address matches, false otherwise.
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/utils/packetbb.cc ns-3.39/src/network/utils/packetbb.cc
--- ns-3.38/src/network/utils/packetbb.cc	2023-03-16 20:54:23.808869100 -0700
+++ ns-3.39/src/network/utils/packetbb.cc	2023-07-05 14:23:48.065428300 -0700
@@ -1508,7 +1508,6 @@
         break;
     default:
         return nullptr;
-        break;
     }
     newmsg->Deserialize(start);
     return newmsg;
@@ -2417,12 +2416,7 @@
         }
     }
 
-    if (m_addressTlvList != other.m_addressTlvList)
-    {
-        return false;
-    }
-
-    return true;
+    return m_addressTlvList == other.m_addressTlvList;
 }
 
 bool
@@ -2439,13 +2433,10 @@
     {
     case 0:
         return 0;
-        break;
     case 1:
         return AHAS_SINGLE_PRE_LEN;
-        break;
     default:
         return AHAS_MULTI_PRE_LEN;
-        break;
     }
 
     /* Quiet compiler */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/utils/packet-socket.cc ns-3.39/src/network/utils/packet-socket.cc
--- ns-3.38/src/network/utils/packet-socket.cc	2023-03-16 20:54:23.808869100 -0700
+++ ns-3.39/src/network/utils/packet-socket.cc	2023-07-05 14:23:48.065428300 -0700
@@ -87,14 +87,14 @@
     m_device = 0;
 }
 
-enum Socket::SocketErrno
+Socket::SocketErrno
 PacketSocket::GetErrno() const
 {
     NS_LOG_FUNCTION(this);
     return m_errno;
 }
 
-enum Socket::SocketType
+Socket::SocketType
 PacketSocket::GetSocketType() const
 {
     NS_LOG_FUNCTION(this);
@@ -520,11 +520,7 @@
 PacketSocket::SetAllowBroadcast(bool allowBroadcast)
 {
     NS_LOG_FUNCTION(this << allowBroadcast);
-    if (allowBroadcast)
-    {
-        return false;
-    }
-    return true;
+    return !allowBroadcast;
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/utils/pcap-file.cc ns-3.39/src/network/utils/pcap-file.cc
--- ns-3.38/src/network/utils/pcap-file.cc	2023-03-16 20:54:23.808869100 -0700
+++ ns-3.39/src/network/utils/pcap-file.cc	2023-07-05 14:23:48.065428300 -0700
@@ -225,7 +225,7 @@
     //
     PcapFileHeader* headerOut = nullptr;
 
-    if (m_swapMode == false)
+    if (!m_swapMode)
     {
         headerOut = &m_fileHeader;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/utils/simple-net-device.cc ns-3.39/src/network/utils/simple-net-device.cc
--- ns-3.38/src/network/utils/simple-net-device.cc	2023-03-16 20:54:23.812869000 -0700
+++ ns-3.39/src/network/utils/simple-net-device.cc	2023-07-05 14:23:48.065428300 -0700
@@ -373,11 +373,7 @@
 SimpleNetDevice::IsBroadcast() const
 {
     NS_LOG_FUNCTION(this);
-    if (m_pointToPointMode)
-    {
-        return false;
-    }
-    return true;
+    return !m_pointToPointMode;
 }
 
 Address
@@ -391,11 +387,7 @@
 SimpleNetDevice::IsMulticast() const
 {
     NS_LOG_FUNCTION(this);
-    if (m_pointToPointMode)
-    {
-        return false;
-    }
-    return true;
+    return !m_pointToPointMode;
 }
 
 Address
@@ -416,11 +408,7 @@
 SimpleNetDevice::IsPointToPoint() const
 {
     NS_LOG_FUNCTION(this);
-    if (m_pointToPointMode)
-    {
-        return true;
-    }
-    return false;
+    return m_pointToPointMode;
 }
 
 bool
@@ -538,11 +526,7 @@
 SimpleNetDevice::NeedsArp() const
 {
     NS_LOG_FUNCTION(this);
-    if (m_pointToPointMode)
-    {
-        return false;
-    }
-    return true;
+    return !m_pointToPointMode;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/nix-vector-routing/model/nix-vector-routing.cc ns-3.39/src/nix-vector-routing/model/nix-vector-routing.cc
--- ns-3.38/src/nix-vector-routing/model/nix-vector-routing.cc	2023-03-16 20:54:23.812869000 -0700
+++ ns-3.39/src/nix-vector-routing/model/nix-vector-routing.cc	2023-07-05 14:23:48.065428300 -0700
@@ -870,10 +870,10 @@
 NixVectorRouting<T>::RouteInput(Ptr<const Packet> p,
                                 const IpHeader& header,
                                 Ptr<const NetDevice> idev,
-                                UnicastForwardCallback ucb,
-                                MulticastForwardCallback mcb,
-                                LocalDeliverCallback lcb,
-                                ErrorCallback ecb)
+                                const UnicastForwardCallback& ucb,
+                                const MulticastForwardCallback& mcb,
+                                const LocalDeliverCallback& lcb,
+                                const ErrorCallback& ecb)
 {
     NS_LOG_FUNCTION(this << p << header << header.GetSource() << header.GetDestination() << idev);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/nix-vector-routing/model/nix-vector-routing.h ns-3.39/src/nix-vector-routing/model/nix-vector-routing.h
--- ns-3.38/src/nix-vector-routing/model/nix-vector-routing.h	2023-03-16 20:54:23.812869000 -0700
+++ ns-3.39/src/nix-vector-routing/model/nix-vector-routing.h	2023-07-05 14:23:48.065428300 -0700
@@ -365,10 +365,10 @@
     virtual bool RouteInput(Ptr<const Packet> p,
                             const IpHeader& header,
                             Ptr<const NetDevice> idev,
-                            UnicastForwardCallback ucb,
-                            MulticastForwardCallback mcb,
-                            LocalDeliverCallback lcb,
-                            ErrorCallback ecb);
+                            const UnicastForwardCallback& ucb,
+                            const MulticastForwardCallback& mcb,
+                            const LocalDeliverCallback& lcb,
+                            const ErrorCallback& ecb);
 
     /**
      * \param interface the index of the interface we are being notified about
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/nix-vector-routing/test/examples-to-run.py ns-3.39/src/nix-vector-routing/test/examples-to-run.py
--- ns-3.38/src/nix-vector-routing/test/examples-to-run.py	2023-03-16 20:54:23.812869000 -0700
+++ ns-3.39/src/nix-vector-routing/test/examples-to-run.py	2023-07-05 14:23:48.065428300 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/olsr/model/olsr-header.cc ns-3.39/src/olsr/model/olsr-header.cc
--- ns-3.38/src/olsr/model/olsr-header.cc	2023-03-16 20:54:23.812869000 -0700
+++ ns-3.39/src/olsr/model/olsr-header.cc	2023-07-05 14:23:48.069428200 -0700
@@ -399,7 +399,7 @@
 MessageHeader::Hello::Print(std::ostream& os) const
 {
     os << " Interval: " << +hTime << " (" << EmfToSeconds(hTime) << "s)";
-    os << " Willingness: " << +willingness;
+    os << " Willingness: " << willingness;
 
     for (const auto& ilinkMessage : linkMessages)
     {
@@ -430,7 +430,7 @@
 
     i.WriteU16(0); // Reserved
     i.WriteU8(this->hTime);
-    i.WriteU8(this->willingness);
+    i.WriteU8(static_cast<uint8_t>(this->willingness));
 
     for (std::vector<LinkMessage>::const_iterator iter = this->linkMessages.begin();
          iter != this->linkMessages.end();
@@ -470,7 +470,7 @@
 
     i.ReadNtohU16(); // Reserved
     this->hTime = i.ReadU8();
-    this->willingness = i.ReadU8();
+    this->willingness = Willingness(i.ReadU8());
 
     helloSizeLeft -= 4;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/olsr/model/olsr-header.h ns-3.39/src/olsr/model/olsr-header.h
--- ns-3.38/src/olsr/model/olsr-header.h	2023-03-16 20:54:23.812869000 -0700
+++ ns-3.39/src/olsr/model/olsr-header.h	2023-07-05 14:23:48.069428200 -0700
@@ -20,6 +20,8 @@
 #ifndef OLSR_HEADER_H
 #define OLSR_HEADER_H
 
+#include "olsr-repositories.h"
+
 #include "ns3/header.h"
 #include "ns3/ipv4-address.h"
 #include "ns3/nstime.h"
@@ -412,8 +414,8 @@
             return Seconds(EmfToSeconds(this->hTime));
         }
 
-        uint8_t willingness; //!< The willingness of a node to carry and forward traffic for other
-                             //!< nodes.
+        Willingness willingness; //!< The willingness of a node to carry and forward traffic for
+                                 //!< other nodes.
         std::vector<LinkMessage> linkMessages; //!< Link messages container.
 
         /**
@@ -684,14 +686,14 @@
     }
 };
 
-static inline std::ostream&
+inline std::ostream&
 operator<<(std::ostream& os, const PacketHeader& packet)
 {
     packet.Print(os);
     return os;
 }
 
-static inline std::ostream&
+inline std::ostream&
 operator<<(std::ostream& os, const MessageHeader& message)
 {
     message.Print(os);
@@ -700,7 +702,7 @@
 
 typedef std::vector<MessageHeader> MessageList;
 
-static inline std::ostream&
+inline std::ostream&
 operator<<(std::ostream& os, const MessageList& messages)
 {
     os << "[";
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/olsr/model/olsr-repositories.h ns-3.39/src/olsr/model/olsr-repositories.h
--- ns-3.38/src/olsr/model/olsr-repositories.h	2023-03-16 20:54:23.812869000 -0700
+++ ns-3.39/src/olsr/model/olsr-repositories.h	2023-07-05 14:23:48.069428200 -0700
@@ -25,6 +25,7 @@
 #include "ns3/ipv4-address.h"
 #include "ns3/nstime.h"
 
+#include <iostream>
 #include <set>
 #include <vector>
 
@@ -33,6 +34,52 @@
 namespace olsr
 {
 
+/**
+ * \ingroup olsr
+ *
+ * Willingness for forwarding packets from other nodes.
+ * The standard defines the following set of values.
+ * Values 0 - 7 are allowed by the standard, but this is not enforced in the code.
+ *
+ * See \RFC{3626} section 18.8
+ */
+enum Willingness : uint8_t
+{
+    NEVER = 0,
+    LOW = 1,
+    DEFAULT = 3, // medium
+    HIGH = 6,
+    ALWAYS = 7,
+};
+
+/**
+ * Stream insertion operator for OLSR willingness.
+ *
+ * \param os Output stream.
+ * \param willingness Willingness.
+ * \return A reference to the output stream.
+ */
+inline std::ostream&
+operator<<(std::ostream& os, Willingness willingness)
+{
+    switch (willingness)
+    {
+    case Willingness::NEVER:
+        return (os << "NEVER");
+    case Willingness::LOW:
+        return (os << "LOW");
+    case Willingness::DEFAULT:
+        return (os << "DEFAULT");
+    case Willingness::HIGH:
+        return (os << "HIGH");
+    case Willingness::ALWAYS:
+        return (os << "ALWAYS");
+    default:
+        return (os << static_cast<uint32_t>(willingness)); // Cast to uint32_t to print correctly
+    }
+    return os;
+}
+
 /// \ingroup olsr
 /// An Interface Association Tuple.
 struct IfaceAssocTuple
@@ -45,13 +92,13 @@
     Time time;
 };
 
-static inline bool
+inline bool
 operator==(const IfaceAssocTuple& a, const IfaceAssocTuple& b)
 {
     return (a.ifaceAddr == b.ifaceAddr && a.mainAddr == b.mainAddr);
 }
 
-static inline std::ostream&
+inline std::ostream&
 operator<<(std::ostream& os, const IfaceAssocTuple& tuple)
 {
     os << "IfaceAssocTuple(ifaceAddr=" << tuple.ifaceAddr << ", mainAddr=" << tuple.mainAddr
@@ -75,13 +122,13 @@
     Time time;
 };
 
-static inline bool
+inline bool
 operator==(const LinkTuple& a, const LinkTuple& b)
 {
     return (a.localIfaceAddr == b.localIfaceAddr && a.neighborIfaceAddr == b.neighborIfaceAddr);
 }
 
-static inline std::ostream&
+inline std::ostream&
 operator<<(std::ostream& os, const LinkTuple& tuple)
 {
     os << "LinkTuple(localIfaceAddr=" << tuple.localIfaceAddr
@@ -109,22 +156,22 @@
 
     /// A value between 0 and 7 specifying the node's willingness to carry traffic on behalf of
     /// other nodes.
-    uint8_t willingness;
+    Willingness willingness;
 };
 
-static inline bool
+inline bool
 operator==(const NeighborTuple& a, const NeighborTuple& b)
 {
     return (a.neighborMainAddr == b.neighborMainAddr && a.status == b.status &&
             a.willingness == b.willingness);
 }
 
-static inline std::ostream&
+inline std::ostream&
 operator<<(std::ostream& os, const NeighborTuple& tuple)
 {
     os << "NeighborTuple(neighborMainAddr=" << tuple.neighborMainAddr
        << ", status=" << (tuple.status == NeighborTuple::STATUS_SYM ? "SYM" : "NOT_SYM")
-       << ", willingness=" << (int)tuple.willingness << ")";
+       << ", willingness=" << tuple.willingness << ")";
     return os;
 }
 
@@ -140,7 +187,7 @@
     Time expirationTime; // previously called 'time_'
 };
 
-static inline std::ostream&
+inline std::ostream&
 operator<<(std::ostream& os, const TwoHopNeighborTuple& tuple)
 {
     os << "TwoHopNeighborTuple(neighborMainAddr=" << tuple.neighborMainAddr
@@ -149,7 +196,7 @@
     return os;
 }
 
-static inline bool
+inline bool
 operator==(const TwoHopNeighborTuple& a, const TwoHopNeighborTuple& b)
 {
     return (a.neighborMainAddr == b.neighborMainAddr &&
@@ -166,7 +213,7 @@
     Time expirationTime; // previously called 'time_'
 };
 
-static inline bool
+inline bool
 operator==(const MprSelectorTuple& a, const MprSelectorTuple& b)
 {
     return (a.mainAddr == b.mainAddr);
@@ -191,7 +238,7 @@
     Time expirationTime;
 };
 
-static inline bool
+inline bool
 operator==(const DuplicateTuple& a, const DuplicateTuple& b)
 {
     return (a.address == b.address && a.sequenceNumber == b.sequenceNumber);
@@ -211,14 +258,14 @@
     Time expirationTime;
 };
 
-static inline bool
+inline bool
 operator==(const TopologyTuple& a, const TopologyTuple& b)
 {
     return (a.destAddr == b.destAddr && a.lastAddr == b.lastAddr &&
             a.sequenceNumber == b.sequenceNumber);
 }
 
-static inline std::ostream&
+inline std::ostream&
 operator<<(std::ostream& os, const TopologyTuple& tuple)
 {
     os << "TopologyTuple(destAddr=" << tuple.destAddr << ", lastAddr=" << tuple.lastAddr
@@ -235,13 +282,13 @@
     Ipv4Mask netmask;        //!< IPv4 Network mask.
 };
 
-static inline bool
+inline bool
 operator==(const Association& a, const Association& b)
 {
     return (a.networkAddr == b.networkAddr && a.netmask == b.netmask);
 }
 
-static inline std::ostream&
+inline std::ostream&
 operator<<(std::ostream& os, const Association& tuple)
 {
     os << "Association(networkAddr=" << tuple.networkAddr << ", netmask=" << tuple.netmask << ")";
@@ -262,14 +309,14 @@
     Time expirationTime;
 };
 
-static inline bool
+inline bool
 operator==(const AssociationTuple& a, const AssociationTuple& b)
 {
     return (a.gatewayAddr == b.gatewayAddr && a.networkAddr == b.networkAddr &&
             a.netmask == b.netmask);
 }
 
-static inline std::ostream&
+inline std::ostream&
 operator<<(std::ostream& os, const AssociationTuple& tuple)
 {
     os << "AssociationTuple(gatewayAddr=" << tuple.gatewayAddr
